import { registerExtension } from '@codingame/monaco-vscode-api/extensions';

const manifest = {"name":"elixir-ls","displayName":"ElixirLS: Elixir support and debugger","homepage":"https://github.com/elixir-lsp/elixir-ls","repository":{"type":"git","url":"https://github.com/elixir-lsp/vscode-elixir-ls.git"},"icon":"images/logo.png","description":"Elixir support with debugger, autocomplete, and more - Powered by ElixirLS.","author":"The Elixir community","license":"MIT","publisher":"JakeBecker","version":"0.26.4","engines":{"vscode":"^1.93.0"},"sponsor":{"url":"https://github.com/sponsors/elixir-lsp"},"categories":["Programming Languages","Debuggers","Linters","Testing","Formatters"],"keywords":["elixir","mix","dialyzer","multi-root ready"],"contributes":{"configurationDefaults":{"[elixir]":{"editor.insertSpaces":true,"editor.tabSize":2,"editor.wordBasedSuggestions":"off","editor.formatOnType":true,"editor.trimAutoWhitespace":false,"editor.snippetSuggestions":"inline","files.trimTrailingWhitespace":true,"files.insertFinalNewline":true,"files.trimFinalNewlines":true},"[eex]":{"editor.trimAutoWhitespace":false,"editor.snippetSuggestions":"inline","files.trimTrailingWhitespace":true,"files.insertFinalNewline":true,"files.trimFinalNewlines":true},"[html-eex]":{"editor.trimAutoWhitespace":false,"editor.snippetSuggestions":"inline","files.trimTrailingWhitespace":true,"files.insertFinalNewline":true,"files.trimFinalNewlines":true}},"configuration":{"title":"ElixirLS","properties":{"elixirLS.autoBuild":{"scope":"resource","type":"boolean","default":true,"description":"Trigger ElixirLS build when code is saved"},"elixirLS.dialyzerEnabled":{"scope":"resource","type":"boolean","default":true,"description":"Run ElixirLS's rapid Dialyzer when code is saved"},"elixirLS.incrementalDialyzer":{"scope":"resource","type":"boolean","default":true,"description":"Use OTP incremental dialyzer (available on OTP 26+)"},"elixirLS.dialyzerWarnOpts":{"scope":"resource","description":"Dialyzer options to enable or disable warnings - See Dialyzer's documentation for options. Note that the \"race_conditions\" option is unsupported","type":"array","uniqueItems":true,"items":{"type":"string","enum":["no_return","no_unused","no_unknown","no_improper_lists","no_fun_app","no_match","no_opaque","no_fail_call","no_contracts","no_behaviours","no_undefined_callbacks","unmatched_returns","error_handling","no_missing_calls","specdiffs","overspecs","underspecs","no_underspecs","extra_return","no_extra_return","missing_return","no_missing_return","unknown","overlapping_contract"]},"default":[]},"elixirLS.dialyzerFormat":{"scope":"resource","description":"Formatter to use for Dialyzer warnings","type":"string","enum":["dialyzer","dialyxir_short","dialyxir_long"],"markdownEnumDescriptions":["Original Dialyzer format","Same as `mix dialyzer --format short`","Same as `mix dialyzer --format long`"],"default":"dialyxir_long"},"elixirLS.envVariables":{"scope":"resource","type":"object","description":"Environment variables to use for compilation","minLength":0},"elixirLS.mixEnv":{"scope":"resource","type":"string","description":"Mix environment to use for compilation","default":"test","minLength":1},"elixirLS.mixTarget":{"scope":"resource","type":"string","description":"Mix target to use for compilation","minLength":0},"elixirLS.projectDir":{"scope":"resource","type":"string","description":"Subdirectory containing Mix project if not in the project root","minLength":0,"default":""},"elixirLS.useCurrentRootFolderAsProjectDir":{"scope":"resource","type":"boolean","description":"Don't try to look for mix.exs in parent directories","default":false},"elixirLS.fetchDeps":{"scope":"resource","type":"boolean","description":"Automatically fetch project dependencies when compiling.","default":false},"elixirLS.suggestSpecs":{"scope":"resource","type":"boolean","description":"Suggest @spec annotations inline using Dialyzer's inferred success typings (Requires Dialyzer).","default":true},"elixirLS.trace.server":{"scope":"window","type":"string","enum":["off","messages","verbose"],"default":"off","description":"Traces the communication between VS Code and the Elixir language server."},"elixirLS.autoInsertRequiredAlias":{"scope":"window","type":"boolean","description":"Enable auto-insert required alias. This is true (enabled) by default.","default":true},"elixirLS.signatureAfterComplete":{"scope":"resource","type":"boolean","description":"Show signature help after confirming autocomplete.","default":true},"elixirLS.enableTestLenses":{"scope":"resource","type":"boolean","description":"Show code lenses to run tests in terminal.","default":false},"elixirLS.additionalWatchedExtensions":{"scope":"resource","type":"array","description":"Additional file types capable of triggering a build on change","uniqueItems":true,"items":{"type":"string"},"default":[]},"elixirLS.languageServerOverridePath":{"scope":"resource","type":"string","description":"Absolute path to alternative ElixirLS release that will override the packaged release","minLength":0}}},"languages":[{"id":"elixir","aliases":["Elixir","elixir"],"extensions":[".ex",".exs"],"filenames":["mix.lock"],"configuration":"./elixir-language-configuration.json"},{"id":"eex","aliases":["Embedded Elixir","EEx","eex"],"extensions":[".eex",".leex"],"configuration":"./eex-language-configuration.json"},{"id":"html-eex","aliases":["HTML (Embedded Elixir)","HTML (EEx)"],"extensions":[".html.eex",".html.leex"],"configuration":"./eex-language-configuration.json"}],"grammars":[{"language":"elixir","scopeName":"source.elixir","path":"./syntaxes/elixir.json","unbalancedBracketScopes":["keyword.operator.bitwise.elixir","keyword.operator.other.unbalanced.elixir","constant.language.symbol.elixir","constant.language.symbol.single-quoted.elixir","constant.language.symbol.double-quoted.elixir","entity.name.function.call.dot.elixir"],"embeddedLanguages":{"comment.documentation.heredoc.elixir":"markdown"}},{"language":"eex","scopeName":"text.elixir","path":"./syntaxes/eex.json"},{"language":"html-eex","scopeName":"text.html.elixir","path":"./syntaxes/html-eex.json"}],"problemMatchers":[{"name":"mixCompileError","owner":"elixir","fileLocation":["relative","${workspaceRoot}"],"severity":"error","pattern":{"regexp":"^\\*\\* \\((\\w+)\\) (.*):(\\d+): (.*)$","file":2,"location":3,"message":0}},{"name":"mixCompileWarning","owner":"elixir","fileLocation":["relative","${workspaceRoot}"],"severity":"warning","pattern":[{"regexp":"^warning: (.*)$","message":1},{"regexp":"^  (.*):(\\d+)(.*)$","file":1,"location":2,"message":3}]},{"name":"mixTestFailure","owner":"elixir","fileLocation":["relative","${workspaceRoot}"],"severity":"warning","pattern":[{"regexp":"^\\s*\\d+\\) (.*)$","message":1},{"regexp":"^\\s*(.*):(\\d+)$","file":1,"location":2}]}]}};

const { registerFileUrl, whenReady } = registerExtension(manifest, undefined, {"system":true,"readmePath":"README.md","changelogPath":"CHANGELOG.md"});


registerFileUrl('CHANGELOG.md', new URL('../assets/JakeBecker.elixir-ls-0.26.4.vsix/CHANGELOG.md', import.meta.url).href, {"mimeType":"text/markdown","size":74797});

registerFileUrl('README.md', new URL('../assets/JakeBecker.elixir-ls-0.26.4.vsix/README.md', import.meta.url).href, {"mimeType":"text/markdown","size":11296});

registerFileUrl('eex-language-configuration.json', new URL('../assets/JakeBecker.elixir-ls-0.26.4.vsix/eex-language-configuration.json', import.meta.url).href, {"mimeType":"application/json","size":1112});

registerFileUrl('elixir-language-configuration.json', new URL('../assets/JakeBecker.elixir-ls-0.26.4.vsix/elixir-language-configuration.json', import.meta.url).href, {"mimeType":"application/json","size":6364});

registerFileUrl('images/logo.png', new URL('../assets/JakeBecker.elixir-ls-0.26.4.vsix/logo.png', import.meta.url).href, {"mimeType":"image/png","size":46261});

registerFileUrl('package.json', new URL('../assets/JakeBecker.elixir-ls-0.26.4.vsix/package.json', import.meta.url).href, {"mimeType":"application/json","size":22421});

registerFileUrl('syntaxes/eex.json', new URL('../assets/JakeBecker.elixir-ls-0.26.4.vsix/eex.json', import.meta.url).href, {"mimeType":"application/json","size":858});

registerFileUrl('syntaxes/elixir.json', new URL('../assets/JakeBecker.elixir-ls-0.26.4.vsix/elixir.json', import.meta.url).href, {"mimeType":"application/json","size":68809});

registerFileUrl('syntaxes/html-eex.json', new URL('../assets/JakeBecker.elixir-ls-0.26.4.vsix/html-eex.json', import.meta.url).href, {"mimeType":"application/json","size":875});

export { whenReady };
