import { registerExtension } from '@codingame/monaco-vscode-api/extensions';

const manifest = {"name":"csharp","publisher":"ms-dotnettools","version":"2.63.31","description":"Base language support for C#","displayName":"C#","author":"Microsoft Corporation","license":"SEE LICENSE IN RuntimeLicenses/license.txt","qna":"https://github.com/dotnet/vscode-csharp/issues","icon":"images/csharpIcon.png","preview":false,"bugs":{"url":"https://github.com/dotnet/vscode-csharp"},"repository":{"type":"git","url":"https://github.com/dotnet/vscode-csharp"},"categories":["Debuggers","Programming Languages","Linters","Snippets"],"keywords":["multi-root ready",".NET","ASP.NET",".NET Core","dotnet","coreclr"],"capabilities":{"virtualWorkspaces":false,"untrustedWorkspaces":{"supported":false}},"defaults":{"roslyn":"4.14.0-1.25074.7","omniSharp":"1.39.12","razor":"9.0.0-preview.25064.4","razorOmnisharp":"7.0.0-preview.23363.1","xamlTools":"17.14.35723.260"},"brokeredServices":[{"moniker":{"name":"Microsoft.CodeAnalysis.LanguageClient.SolutionSnapshotProvider","version":"0.1"}},{"moniker":{"name":"Microsoft.VisualStudio.CSharpExtension.BuildResultService","version":"0.1"}}],"runtimeDependencies":[{"id":"OmniSharp","description":"OmniSharp for Windows (.NET 4.7.2 / x64)","url":"https://roslynomnisharp.blob.core.windows.net/releases/1.39.12/omnisharp-win-x64-1.39.12.zip","installPath":".omnisharp/1.39.12","platforms":["win32"],"architectures":["x86_64"],"installTestPath":"./.omnisharp/1.39.12/OmniSharp.exe","platformId":"win-x64","isFramework":true,"integrity":"A52562B44C9BAA2811F0A617F182A5886BB79BB1532850827D89F173D8C962B6"},{"id":"OmniSharp","description":"OmniSharp for Windows (.NET 6 / x64)","url":"https://roslynomnisharp.blob.core.windows.net/releases/1.39.12/omnisharp-win-x64-net6.0-1.39.12.zip","installPath":".omnisharp/1.39.12-net6.0","platforms":["win32"],"architectures":["x86_64"],"installTestPath":"./.omnisharp/1.39.12-net6.0/OmniSharp.dll","platformId":"win-x64","isFramework":false,"integrity":"21BB3F7D990B6D464A748E9C11731582CAEEAAB87D7F749EDEACFE136A09C13E"},{"id":"OmniSharp","description":"OmniSharp for Windows (.NET 4.7.2 / arm64)","url":"https://roslynomnisharp.blob.core.windows.net/releases/1.39.12/omnisharp-win-arm64-1.39.12.zip","installPath":".omnisharp/1.39.12","platforms":["win32"],"architectures":["arm64"],"installTestPath":"./.omnisharp/1.39.12/OmniSharp.exe","platformId":"win-arm64","isFramework":true,"integrity":"E61CFBD416C9099D5710748281A0E07763ABE6D6EC930F31335B008DB6907780"},{"id":"OmniSharp","description":"OmniSharp for Windows (.NET 6 / arm64)","url":"https://roslynomnisharp.blob.core.windows.net/releases/1.39.12/omnisharp-win-arm64-net6.0-1.39.12.zip","installPath":".omnisharp/1.39.12-net6.0","platforms":["win32"],"architectures":["arm64"],"installTestPath":"./.omnisharp/1.39.12-net6.0/OmniSharp.dll","platformId":"win-arm64","isFramework":false,"integrity":"ECA34E2AEEB1775AAB664C5C06232EFBB57BB2CA6020A63FB92D24A0EE3A6906"},{"id":"OmniSharp","description":"OmniSharp for OSX (Mono / x64)","url":"https://roslynomnisharp.blob.core.windows.net/releases/1.39.12/omnisharp-osx-1.39.12.zip","installPath":".omnisharp/1.39.12","platforms":["darwin"],"architectures":["x86_64","arm64"],"binaries":["./mono.osx","./run"],"installTestPath":"./.omnisharp/1.39.12/run","platformId":"osx","isFramework":true,"integrity":"645BD54508011CEF386FC765FA9E2DD6F6615120A6F611EF78DB2C41A3634C71"},{"id":"OmniSharp","description":"OmniSharp for OSX (.NET 6 / x64)","url":"https://roslynomnisharp.blob.core.windows.net/releases/1.39.12/omnisharp-osx-x64-net6.0-1.39.12.zip","installPath":".omnisharp/1.39.12-net6.0","platforms":["darwin"],"architectures":["x86_64"],"installTestPath":"./.omnisharp/1.39.12-net6.0/OmniSharp.dll","platformId":"osx-x64","isFramework":false,"integrity":"04A286EA36CE60AD1EBC83E16B114FD6663BDE840C43FD695067268A39B81CB1"},{"id":"OmniSharp","description":"OmniSharp for OSX (.NET 6 / arm64)","url":"https://roslynomnisharp.blob.core.windows.net/releases/1.39.12/omnisharp-osx-arm64-net6.0-1.39.12.zip","installPath":".omnisharp/1.39.12-net6.0","platforms":["darwin"],"architectures":["arm64"],"installTestPath":"./.omnisharp/1.39.12-net6.0/OmniSharp.dll","platformId":"osx-arm64","isFramework":false,"integrity":"44A197EBB3FC1AE55209FD3A125F2EDF6327F91A0E1EFC76025B5F7787CC4F94"},{"id":"OmniSharp","description":"OmniSharp for Linux (Mono / x86)","url":"https://roslynomnisharp.blob.core.windows.net/releases/1.39.12/omnisharp-linux-x86-1.39.12.zip","installPath":".omnisharp/1.39.12","platforms":["linux"],"architectures":["x86","i686"],"binaries":["./mono.linux-x86","./run"],"installTestPath":"./.omnisharp/1.39.12/run","platformId":"linux-x86","isFramework":true,"integrity":"7C5691CCA9F617FBCCAA687F3624913428F31FF3213F689E25D62E17CBC0C2DE"},{"id":"OmniSharp","description":"OmniSharp for Linux (Mono / x64)","url":"https://roslynomnisharp.blob.core.windows.net/releases/1.39.12/omnisharp-linux-x64-1.39.12.zip","installPath":".omnisharp/1.39.12","platforms":["linux"],"architectures":["x86_64"],"binaries":["./mono.linux-x86_64","./run"],"installTestPath":"./.omnisharp/1.39.12/run","platformId":"linux-x64","isFramework":true,"integrity":"82997A2EC98CDC213712EE0F96FB5A0A6C0858889D26C6BD7DB2FA1269FD6CBA"},{"id":"OmniSharp","description":"OmniSharp for Linux (.NET 6 / x64)","url":"https://roslynomnisharp.blob.core.windows.net/releases/1.39.12/omnisharp-linux-x64-net6.0-1.39.12.zip","installPath":".omnisharp/1.39.12-net6.0","platforms":["linux"],"architectures":["x86_64"],"installTestPath":"./.omnisharp/1.39.12-net6.0/OmniSharp.dll","platformId":"linux-x64","isFramework":false,"integrity":"7D65424EEEC4D0C06BAEE22D37465AD9718B626D4E9E9CA0E5FB95862630C049"},{"id":"OmniSharp","description":"OmniSharp for Linux (Mono / arm64)","url":"https://roslynomnisharp.blob.core.windows.net/releases/1.39.12/omnisharp-linux-arm64-1.39.12.zip","installPath":".omnisharp/1.39.12","platforms":["linux"],"architectures":["arm64"],"binaries":["./mono.linux-arm64","./run"],"installTestPath":"./.omnisharp/1.39.12/run","platformId":"linux-arm64","isFramework":true,"integrity":"39478AE2072874258CC493055F7332FD9BEC7B3ED1FFF57280EB2D07CAFAE4BD"},{"id":"OmniSharp","description":"OmniSharp for Linux (.NET 6 / arm64)","url":"https://roslynomnisharp.blob.core.windows.net/releases/1.39.12/omnisharp-linux-arm64-net6.0-1.39.12.zip","installPath":".omnisharp/1.39.12-net6.0","platforms":["linux"],"architectures":["arm64"],"installTestPath":"./.omnisharp/1.39.12-net6.0/OmniSharp.dll","platformId":"linux-arm64","isFramework":false,"integrity":"1A009CF2D62D1A6FE1646FFF03FED52633B019B49A71FB3D8CE74406224EA0C5"},{"id":"OmniSharp","description":"OmniSharp for Linux musl (.NET 6 / x64)","url":"https://roslynomnisharp.blob.core.windows.net/releases/1.39.12/omnisharp-linux-musl-x64-net6.0-1.39.12.zip","installPath":".omnisharp/1.39.12-net6.0","platforms":["linux-musl"],"architectures":["x86_64"],"installTestPath":"./.omnisharp/1.39.12-net6.0/OmniSharp.dll","platformId":"linux-musl-x64","isFramework":false,"integrity":"FB97F4B0AB76823272B55CA3134FD5877C5651366CB88C678ED0445E86A8CD35"},{"id":"OmniSharp","description":"OmniSharp for Linux musl (.NET 6 / arm64)","url":"https://roslynomnisharp.blob.core.windows.net/releases/1.39.12/omnisharp-linux-musl-arm64-net6.0-1.39.12.zip","installPath":".omnisharp/1.39.12-net6.0","platforms":["linux-musl"],"architectures":["arm64"],"installTestPath":"./.omnisharp/1.39.12-net6.0/OmniSharp.dll","platformId":"linux-musl-arm64","isFramework":false,"integrity":"9944EBD6EE06BD595BCADD3057CD9BEF4105C3A3952DAE03E54F3114E2E6661F"},{"id":"Debugger","description":".NET Core Debugger (Windows / x64)","url":"https://vsdebugger-cyg0dxb6czfafzaz.b01.azurefd.net/coreclr-debug-2-60-0/coreclr-debug-win7-x64.zip","installPath":".debugger/x86_64","platforms":["win32"],"architectures":["x86_64","arm64"],"installTestPath":"./.debugger/x86_64/vsdbg-ui.exe","integrity":"BFA8E3298DAFE59213BA2FD9938031B7A41A354415274E8238BB49D9E9381E66"},{"id":"Debugger","description":".NET Core Debugger (Windows / ARM64)","url":"https://vsdebugger-cyg0dxb6czfafzaz.b01.azurefd.net/coreclr-debug-2-60-0/coreclr-debug-win10-arm64.zip","installPath":".debugger/arm64","platforms":["win32"],"architectures":["arm64"],"installTestPath":"./.debugger/arm64/vsdbg-ui.exe","integrity":"299DA0ABD00CD61AA1A6293A3C103CCF3070844E4B667C2811A3AAC16D7E6E44"},{"id":"Debugger","description":".NET Core Debugger (macOS / x64)","url":"https://vsdebugger-cyg0dxb6czfafzaz.b01.azurefd.net/coreclr-debug-2-60-0/coreclr-debug-osx-x64.zip","installPath":".debugger/x86_64","platforms":["darwin"],"architectures":["x86_64","arm64"],"binaries":["./vsdbg-ui","./vsdbg"],"installTestPath":"./.debugger/x86_64/vsdbg-ui","integrity":"5DF02935DFFD453E8C947AFC7567F4199D4BD83F582EBB20ECD23C054F8A43E2"},{"id":"Debugger","description":".NET Core Debugger (macOS / arm64)","url":"https://vsdebugger-cyg0dxb6czfafzaz.b01.azurefd.net/coreclr-debug-2-60-0/coreclr-debug-osx-arm64.zip","installPath":".debugger/arm64","platforms":["darwin"],"architectures":["arm64"],"binaries":["./vsdbg-ui","./vsdbg"],"installTestPath":"./.debugger/arm64/vsdbg-ui","integrity":"1CBC75E00B7CE32DBD2617AC59EE10A4FE1DBB5AEA6E6A94224F50DEC3C96D3E"},{"id":"Debugger","description":".NET Core Debugger (linux / ARM)","url":"https://vsdebugger-cyg0dxb6czfafzaz.b01.azurefd.net/coreclr-debug-2-60-0/coreclr-debug-linux-arm.zip","installPath":".debugger","platforms":["linux"],"architectures":["arm"],"binaries":["./vsdbg-ui","./vsdbg"],"installTestPath":"./.debugger/vsdbg-ui","integrity":"AE7B3967783B87448BAC4C78074B1D6F6AD4B70981FBB202CC9150A46405D287"},{"id":"Debugger","description":".NET Core Debugger (linux / ARM64)","url":"https://vsdebugger-cyg0dxb6czfafzaz.b01.azurefd.net/coreclr-debug-2-60-0/coreclr-debug-linux-arm64.zip","installPath":".debugger","platforms":["linux"],"architectures":["arm64"],"binaries":["./vsdbg-ui","./vsdbg"],"installTestPath":"./.debugger/vsdbg-ui","integrity":"468C4577B8E131E47CE83C7A290DA41580C6D327B43308CA8B206D068057CCD0"},{"id":"Debugger","description":".NET Core Debugger (linux musl / x64)","url":"https://vsdebugger-cyg0dxb6czfafzaz.b01.azurefd.net/coreclr-debug-2-60-0/coreclr-debug-linux-musl-x64.zip","installPath":".debugger","platforms":["linux-musl"],"architectures":["x86_64"],"binaries":["./vsdbg-ui","./vsdbg"],"installTestPath":"./.debugger/vsdbg-ui","integrity":"B097E8D5C87B445399829DCDC32C387121E81F6F79001715645B620FC8EFD087"},{"id":"Debugger","description":".NET Core Debugger (linux musl / ARM64)","url":"https://vsdebugger-cyg0dxb6czfafzaz.b01.azurefd.net/coreclr-debug-2-60-0/coreclr-debug-linux-musl-arm64.zip","installPath":".debugger","platforms":["linux-musl"],"architectures":["arm64"],"binaries":["./vsdbg-ui","./vsdbg"],"installTestPath":"./.debugger/vsdbg-ui","integrity":"02CBCBD53377ECDFD68671D216A7CD2631CF22C60CFA66F5361A919F915D0B19"},{"id":"Debugger","description":".NET Core Debugger (linux / x64)","url":"https://vsdebugger-cyg0dxb6czfafzaz.b01.azurefd.net/coreclr-debug-2-60-0/coreclr-debug-linux-x64.zip","installPath":".debugger","platforms":["linux"],"architectures":["x86_64"],"binaries":["./vsdbg-ui","./vsdbg"],"installTestPath":"./.debugger/vsdbg-ui","integrity":"1710E20F9A7BD4F10A126B86D8F3F9F6C2859B7A7EA2E6BACCE7029ACDA57DFB"},{"id":"RazorOmnisharp","description":"Razor Language Server for OmniSharp (Windows / x64)","url":"https://download.visualstudio.microsoft.com/download/pr/aee63398-023f-48db-bba2-30162c68f0c4/8d42e62ea4051381c219b3e31bc4eced/razorlanguageserver-win-x64-7.0.0-preview.23363.1.zip","installPath":".razoromnisharp","platforms":["win32"],"architectures":["x86_64"]},{"id":"RazorOmnisharp","description":"Razor Language Server for OmniSharp (Windows / ARM64)","url":"https://download.visualstudio.microsoft.com/download/pr/aee63398-023f-48db-bba2-30162c68f0c4/4ef26e45cf32fe8d51c0e7dd21f1fef6/razorlanguageserver-win-arm64-7.0.0-preview.23363.1.zip","installPath":".razoromnisharp","platforms":["win32"],"architectures":["arm64"]},{"id":"RazorOmnisharp","description":"Razor Language Server for OmniSharp (Linux / x64)","url":"https://download.visualstudio.microsoft.com/download/pr/aee63398-023f-48db-bba2-30162c68f0c4/6d4e23a3c7cf0465743950a39515a716/razorlanguageserver-linux-x64-7.0.0-preview.23363.1.zip","installPath":".razoromnisharp","platforms":["linux"],"architectures":["x86_64"],"binaries":["./rzls"]},{"id":"RazorOmnisharp","description":"Razor Language Server for OmniSharp (Linux ARM64)","url":"https://download.visualstudio.microsoft.com/download/pr/aee63398-023f-48db-bba2-30162c68f0c4/85deebd44647ebf65724cc291d722283/razorlanguageserver-linux-arm64-7.0.0-preview.23363.1.zip","installPath":".razoromnisharp","platforms":["linux"],"architectures":["arm64"],"binaries":["./rzls"]},{"id":"RazorOmnisharp","description":"Razor Language Server for OmniSharp (Linux musl / x64)","url":"https://download.visualstudio.microsoft.com/download/pr/aee63398-023f-48db-bba2-30162c68f0c4/4f0caa94ae182785655efb15eafcef23/razorlanguageserver-linux-musl-x64-7.0.0-preview.23363.1.zip","installPath":".razoromnisharp","platforms":["linux-musl"],"architectures":["x86_64"],"binaries":["./rzls"]},{"id":"RazorOmnisharp","description":"Razor Language Server for OmniSharp (Linux musl ARM64)","url":"https://download.visualstudio.microsoft.com/download/pr/aee63398-023f-48db-bba2-30162c68f0c4/0a24828206a6f3b4bc743d058ef88ce7/razorlanguageserver-linux-musl-arm64-7.0.0-preview.23363.1.zip","installPath":".razoromnisharp","platforms":["linux-musl"],"architectures":["arm64"],"binaries":["./rzls"]},{"id":"RazorOmnisharp","description":"Razor Language Server for OmniSharp (macOS / x64)","url":"https://download.visualstudio.microsoft.com/download/pr/aee63398-023f-48db-bba2-30162c68f0c4/2afcafaf41082989efcc10405abb9314/razorlanguageserver-osx-x64-7.0.0-preview.23363.1.zip","installPath":".razoromnisharp","platforms":["darwin"],"architectures":["x86_64"],"binaries":["./rzls"]},{"id":"RazorOmnisharp","description":"Razor Language Server for OmniSharp (macOS ARM64)","url":"https://download.visualstudio.microsoft.com/download/pr/aee63398-023f-48db-bba2-30162c68f0c4/8bf2ed2f00d481a5987e3eb5165afddd/razorlanguageserver-osx-arm64-7.0.0-preview.23363.1.zip","installPath":".razoromnisharp","platforms":["darwin"],"architectures":["arm64"],"binaries":["./rzls"]}],"engines":{"vscode":"^1.93.0"},"contributes":{"themes":[{"label":"Visual Studio 2019 Dark","uiTheme":"vs-dark","path":"./themes/vs2019_dark.json"},{"label":"Visual Studio 2019 Light","uiTheme":"vs","path":"./themes/vs2019_light.json"}],"configuration":[{"title":"Project","order":0,"properties":{"dotnet.defaultSolution":{"type":"string","description":"%configuration.dotnet.defaultSolution.description%","order":0}}},{"title":"Text Editor","order":1,"properties":{"dotnet.autoInsert.enableAutoInsert":{"type":"boolean","default":true,"description":"%configuration.dotnet.autoInsert.enableAutoInsert%"},"dotnet.formatting.organizeImportsOnFormat":{"type":"boolean","default":false,"description":"%configuration.dotnet.formatting.organizeImportsOnFormat%"},"dotnet.typeMembers.memberInsertionLocation":{"type":"string","enum":["withOtherMembersOfTheSameKind","atTheEnd"],"default":"withOtherMembersOfTheSameKind","enumDescriptions":["%configuration.dotnet.typeMembers.memberInsertionLocation.withOtherMembersOfTheSameKind%","%configuration.dotnet.typeMembers.memberInsertionLocation.atTheEnd%"],"description":"%configuration.dotnet.typeMembers.memberInsertionLocation%","order":10},"dotnet.typeMembers.propertyGenerationBehavior":{"type":"string","enum":["preferThrowingProperties","preferAutoProperties"],"default":"preferThrowingProperties","enumDescriptions":["%configuration.dotnet.typeMembers.propertyGenerationBehavior.preferThrowingProperties%","%configuration.dotnet.typeMembers.propertyGenerationBehavior.preferAutoProperties%"],"description":"%configuration.dotnet.typeMembers.propertyGenerationBehavior%","order":10},"dotnet.codeLens.enableReferencesCodeLens":{"type":"boolean","default":true,"description":"%configuration.dotnet.codeLens.enableReferencesCodeLens%"},"dotnet.codeLens.enableTestsCodeLens":{"type":"boolean","default":true,"description":"%configuration.dotnet.codeLens.enableTestsCodeLens%"},"dotnet.completion.showCompletionItemsFromUnimportedNamespaces":{"type":"boolean","default":true,"description":"%configuration.dotnet.completion.showCompletionItemsFromUnimportedNamespaces%","order":20},"dotnet.completion.showNameCompletionSuggestions":{"type":"boolean","default":"true","description":"%configuration.dotnet.completion.showNameCompletionSuggestions%","order":20},"dotnet.completion.provideRegexCompletions":{"type":"boolean","default":"true","description":"%configuration.dotnet.completion.provideRegexCompletions%","order":20},"dotnet.completion.triggerCompletionInArgumentLists":{"type":"boolean","default":"true","description":"%configuration.dotnet.completion.triggerCompletionInArgumentLists%","order":20},"dotnet.backgroundAnalysis.analyzerDiagnosticsScope":{"type":"string","enum":["openFiles","fullSolution","none"],"default":"openFiles","enumDescriptions":["%configuration.dotnet.backgroundAnalysis.analyzerDiagnosticsScope.openFiles%","%configuration.dotnet.backgroundAnalysis.analyzerDiagnosticsScope.fullSolution%","%configuration.dotnet.backgroundAnalysis.analyzerDiagnosticsScope.none%"],"description":"%configuration.dotnet.backgroundAnalysis.analyzerDiagnosticsScope%","order":30},"dotnet.backgroundAnalysis.compilerDiagnosticsScope":{"type":"string","enum":["openFiles","fullSolution","none"],"default":"openFiles","enumDescriptions":["%configuration.dotnet.backgroundAnalysis.compilerDiagnosticsScope.openFiles%","%configuration.dotnet.backgroundAnalysis.compilerDiagnosticsScope.fullSolution%","%configuration.dotnet.backgroundAnalysis.compilerDiagnosticsScope.none%"],"description":"%configuration.dotnet.backgroundAnalysis.compilerDiagnosticsScope%","order":30},"dotnet.highlighting.highlightRelatedRegexComponents":{"type":"boolean","default":"true","description":"%configuration.dotnet.highlighting.highlightRelatedRegexComponents%","order":40},"dotnet.highlighting.highlightRelatedJsonComponents":{"type":"boolean","default":"true","description":"%configuration.dotnet.highlighting.highlightRelatedJsonComponents%","order":40},"csharp.inlayHints.enableInlayHintsForImplicitObjectCreation":{"type":"boolean","default":false,"description":"%configuration.csharp.inlayHints.enableInlayHintsForImplicitObjectCreation%","order":50},"csharp.inlayHints.enableInlayHintsForImplicitVariableTypes":{"type":"boolean","default":false,"description":"%configuration.csharp.inlayHints.enableInlayHintsForImplicitVariableTypes%","order":50},"csharp.inlayHints.enableInlayHintsForLambdaParameterTypes":{"type":"boolean","default":false,"description":"%configuration.csharp.inlayHints.enableInlayHintsForLambdaParameterTypes%","order":50},"csharp.inlayHints.enableInlayHintsForTypes":{"type":"boolean","default":false,"description":"%configuration.csharp.inlayHints.enableInlayHintsForTypes%","order":50},"dotnet.inlayHints.enableInlayHintsForIndexerParameters":{"type":"boolean","default":false,"description":"%configuration.csharp.inlayHints.enableInlayHintsForIndexerParameters%","order":50},"dotnet.inlayHints.enableInlayHintsForLiteralParameters":{"type":"boolean","default":false,"description":"%configuration.dotnet.inlayHints.enableInlayHintsForLiteralParameters%","order":50},"dotnet.inlayHints.enableInlayHintsForObjectCreationParameters":{"type":"boolean","default":false,"description":"%configuration.dotnet.inlayHints.enableInlayHintsForObjectCreationParameters%","order":50},"dotnet.inlayHints.enableInlayHintsForOtherParameters":{"type":"boolean","default":false,"description":"%configuration.dotnet.inlayHints.enableInlayHintsForOtherParameters%","order":50},"dotnet.inlayHints.enableInlayHintsForParameters":{"type":"boolean","default":false,"description":"%configuration.dotnet.inlayHints.enableInlayHintsForParameters%","order":50},"dotnet.inlayHints.suppressInlayHintsForParametersThatDifferOnlyBySuffix":{"type":"boolean","default":false,"description":"%configuration.dotnet.inlayHints.suppressInlayHintsForParametersThatDifferOnlyBySuffix%","order":50},"dotnet.inlayHints.suppressInlayHintsForParametersThatMatchArgumentName":{"type":"boolean","default":false,"description":"%configuration.dotnet.inlayHints.suppressInlayHintsForParametersThatMatchArgumentName%","order":50},"dotnet.inlayHints.suppressInlayHintsForParametersThatMatchMethodIntent":{"type":"boolean","default":false,"description":"%configuration.dotnet.inlayHints.suppressInlayHintsForParametersThatMatchMethodIntent%","order":50},"dotnet.navigation.navigateToDecompiledSources":{"type":"boolean","default":"true","description":"%configuration.dotnet.navigation.navigateToDecompiledSources%","order":60},"dotnet.navigation.navigateToSourceLinkAndEmbeddedSources":{"type":"boolean","default":"true","description":"%configuration.dotnet.navigation.navigateToSourceLinkAndEmbeddedSources%","order":60},"dotnet.quickInfo.showRemarksInQuickInfo":{"type":"boolean","default":"true","description":"%configuration.dotnet.quickInfo.showRemarksInQuickInfo%","order":70},"dotnet.symbolSearch.searchReferenceAssemblies":{"type":"boolean","default":true,"description":"%configuration.dotnet.symbolSearch.searchReferenceAssemblies%","order":80}}},{"title":"Debugger","order":8,"properties":{"csharp.debug.stopAtEntry":{"type":"boolean","markdownDescription":"%generateOptionsSchema.stopAtEntry.markdownDescription%","default":false},"csharp.debug.console":{"type":"string","enum":["internalConsole","integratedTerminal","externalTerminal"],"enumDescriptions":["%generateOptionsSchema.console.internalConsole.enumDescription%","%generateOptionsSchema.console.integratedTerminal.enumDescription%","%generateOptionsSchema.console.externalTerminal.enumDescription%"],"markdownDescription":"%generateOptionsSchema.console.settingsDescription%","default":"internalConsole"},"csharp.debug.sourceFileMap":{"type":"object","markdownDescription":"%generateOptionsSchema.sourceFileMap.markdownDescription%","additionalProperties":{"type":"string"},"default":{}},"csharp.debug.justMyCode":{"type":"boolean","markdownDescription":"%generateOptionsSchema.justMyCode.markdownDescription%","default":true},"csharp.debug.requireExactSource":{"type":"boolean","markdownDescription":"%generateOptionsSchema.requireExactSource.markdownDescription%","default":true},"csharp.debug.enableStepFiltering":{"type":"boolean","markdownDescription":"%generateOptionsSchema.enableStepFiltering.markdownDescription%","default":true},"csharp.debug.logging.exceptions":{"type":"boolean","markdownDescription":"%generateOptionsSchema.logging.exceptions.markdownDescription%","default":true},"csharp.debug.logging.moduleLoad":{"type":"boolean","markdownDescription":"%generateOptionsSchema.logging.moduleLoad.markdownDescription%","default":true},"csharp.debug.logging.programOutput":{"type":"boolean","markdownDescription":"%generateOptionsSchema.logging.programOutput.markdownDescription%","default":true},"csharp.debug.logging.browserStdOut":{"type":"boolean","markdownDescription":"%generateOptionsSchema.logging.browserStdOut.markdownDescription%","default":true},"csharp.debug.logging.elapsedTiming":{"type":"boolean","markdownDescription":"%generateOptionsSchema.logging.elapsedTiming.markdownDescription%","default":false},"csharp.debug.logging.threadExit":{"type":"boolean","markdownDescription":"%generateOptionsSchema.logging.threadExit.markdownDescription%","default":false},"csharp.debug.logging.processExit":{"type":"boolean","markdownDescription":"%generateOptionsSchema.logging.processExit.markdownDescription%","default":true},"csharp.debug.logging.engineLogging":{"type":"boolean","deprecationMessage":"%generateOptionsSchema.logging.engineLogging.deprecationMessage%","default":false},"csharp.debug.logging.diagnosticsLog.protocolMessages":{"type":"boolean","markdownDescription":"%generateOptionsSchema.logging.diagnosticsLog.protocolMessages.markdownDescription%","default":false},"csharp.debug.logging.diagnosticsLog.dispatcherMessages":{"type":"string","enum":["none","error","important","normal"],"enumDescriptions":["%generateOptionsSchema.logging.diagnosticsLog.dispatcherMessages.none.enumDescription%","%generateOptionsSchema.logging.diagnosticsLog.dispatcherMessages.error.enumDescription%","%generateOptionsSchema.logging.diagnosticsLog.dispatcherMessages.important.enumDescription%","%generateOptionsSchema.logging.diagnosticsLog.dispatcherMessages.normal.enumDescription%"],"markdownDescription":"%generateOptionsSchema.logging.diagnosticsLog.dispatcherMessages.markdownDescription%","default":"none"},"csharp.debug.logging.diagnosticsLog.debugEngineAPITracing":{"type":"string","enum":["none","error","all"],"enumDescriptions":["%generateOptionsSchema.logging.diagnosticsLog.debugEngineAPITracing.none.enumDescription%","%generateOptionsSchema.logging.diagnosticsLog.debugEngineAPITracing.error.enumDescription%","%generateOptionsSchema.logging.diagnosticsLog.debugEngineAPITracing.all.enumDescription%"],"markdownDescription":"%generateOptionsSchema.logging.diagnosticsLog.debugEngineAPITracing.markdownDescription%","default":"none"},"csharp.debug.logging.diagnosticsLog.debugRuntimeEventTracing":{"type":"boolean","markdownDescription":"%generateOptionsSchema.logging.diagnosticsLog.debugRuntimeEventTracing.markdownDescription%","default":false},"csharp.debug.logging.diagnosticsLog.expressionEvaluationTracing":{"type":"boolean","markdownDescription":"%generateOptionsSchema.logging.diagnosticsLog.expressionEvaluationTracing.markdownDescription%","default":false},"csharp.debug.logging.diagnosticsLog.startDebuggingTracing":{"type":"boolean","markdownDescription":"%generateOptionsSchema.logging.diagnosticsLog.startDebuggingTracing.markdownDescription%","default":false},"csharp.debug.logging.consoleUsageMessage":{"type":"boolean","description":"%generateOptionsSchema.logging.consoleUsageMessage.description%","default":true},"csharp.debug.suppressJITOptimizations":{"type":"boolean","markdownDescription":"%generateOptionsSchema.suppressJITOptimizations.markdownDescription%","default":false},"csharp.debug.symbolOptions.searchPaths":{"type":"array","items":{"type":"string"},"description":"%generateOptionsSchema.symbolOptions.searchPaths.description%","default":[]},"csharp.debug.symbolOptions.searchMicrosoftSymbolServer":{"type":"boolean","description":"%generateOptionsSchema.symbolOptions.searchMicrosoftSymbolServer.description%","default":false},"csharp.debug.symbolOptions.searchNuGetOrgSymbolServer":{"type":"boolean","description":"%generateOptionsSchema.symbolOptions.searchNuGetOrgSymbolServer.description%","default":false},"csharp.debug.symbolOptions.cachePath":{"type":"string","description":"%generateOptionsSchema.symbolOptions.cachePath.description%","default":""},"csharp.debug.symbolOptions.moduleFilter.mode":{"type":"string","enum":["loadAllButExcluded","loadOnlyIncluded"],"enumDescriptions":["%generateOptionsSchema.symbolOptions.moduleFilter.mode.loadAllButExcluded.enumDescription%","%generateOptionsSchema.symbolOptions.moduleFilter.mode.loadOnlyIncluded.enumDescription%"],"description":"%generateOptionsSchema.symbolOptions.moduleFilter.mode.description%","default":"loadAllButExcluded"},"csharp.debug.symbolOptions.moduleFilter.excludedModules":{"type":"array","items":{"type":"string"},"description":"%generateOptionsSchema.symbolOptions.moduleFilter.excludedModules.description%","default":[]},"csharp.debug.symbolOptions.moduleFilter.includedModules":{"type":"array","items":{"type":"string"},"description":"%generateOptionsSchema.symbolOptions.moduleFilter.includedModules.description%","default":[]},"csharp.debug.symbolOptions.moduleFilter.includeSymbolsNextToModules":{"type":"boolean","description":"%generateOptionsSchema.symbolOptions.moduleFilter.includeSymbolsNextToModules.description%","default":true},"csharp.debug.symbolOptions.moduleFilter.includeSymbolsOnDemand":{"type":"boolean","description":"%generateOptionsSchema.symbolOptions.moduleFilter.includeSymbolsOnDemand.description%","default":true},"csharp.debug.expressionEvaluationOptions.allowImplicitFuncEval":{"type":"boolean","description":"%generateOptionsSchema.expressionEvaluationOptions.allowImplicitFuncEval.description%","default":true},"csharp.debug.expressionEvaluationOptions.allowToString":{"type":"boolean","markdownDescription":"%generateOptionsSchema.expressionEvaluationOptions.allowToString.markdownDescription%","default":true},"csharp.debug.expressionEvaluationOptions.allowFastEvaluate":{"type":"boolean","description":"%generateOptionsSchema.expressionEvaluationOptions.allowFastEvaluate.description%","default":true},"csharp.debug.expressionEvaluationOptions.showRawValues":{"type":"boolean","description":"%generateOptionsSchema.expressionEvaluationOptions.showRawValues.description%","default":false},"dotnet.unitTestDebuggingOptions":{"type":"object","description":"%configuration.dotnet.unitTestDebuggingOptions%","default":{},"properties":{"sourceFileMap":{"type":"object","markdownDescription":"%generateOptionsSchema.sourceFileMap.markdownDescription%","additionalProperties":{"type":"string"}},"justMyCode":{"type":"boolean","markdownDescription":"%generateOptionsSchema.justMyCode.markdownDescription%","default":true},"requireExactSource":{"type":"boolean","markdownDescription":"%generateOptionsSchema.requireExactSource.markdownDescription%","default":true},"enableStepFiltering":{"type":"boolean","markdownDescription":"%generateOptionsSchema.enableStepFiltering.markdownDescription%","default":true},"logging":{"description":"%generateOptionsSchema.logging.description%","type":"object","required":[],"default":{},"properties":{"exceptions":{"type":"boolean","markdownDescription":"%generateOptionsSchema.logging.exceptions.markdownDescription%","default":true},"moduleLoad":{"type":"boolean","markdownDescription":"%generateOptionsSchema.logging.moduleLoad.markdownDescription%","default":true},"programOutput":{"type":"boolean","markdownDescription":"%generateOptionsSchema.logging.programOutput.markdownDescription%","default":true},"threadExit":{"type":"boolean","markdownDescription":"%generateOptionsSchema.logging.threadExit.markdownDescription%","default":false},"processExit":{"type":"boolean","markdownDescription":"%generateOptionsSchema.logging.processExit.markdownDescription%","default":true}}},"suppressJITOptimizations":{"type":"boolean","markdownDescription":"%generateOptionsSchema.suppressJITOptimizations.markdownDescription%","default":false},"symbolOptions":{"description":"%generateOptionsSchema.symbolOptions.description%","default":{"searchPaths":[],"searchMicrosoftSymbolServer":false,"searchNuGetOrgSymbolServer":false},"type":"object","properties":{"searchPaths":{"type":"array","items":{"type":"string"},"description":"%generateOptionsSchema.symbolOptions.searchPaths.description%","default":[]},"searchMicrosoftSymbolServer":{"type":"boolean","description":"%generateOptionsSchema.symbolOptions.searchMicrosoftSymbolServer.description%","default":false},"searchNuGetOrgSymbolServer":{"type":"boolean","description":"%generateOptionsSchema.symbolOptions.searchNuGetOrgSymbolServer.description%","default":false},"cachePath":{"type":"string","description":"%generateOptionsSchema.symbolOptions.cachePath.description%","default":""},"moduleFilter":{"description":"%generateOptionsSchema.symbolOptions.moduleFilter.description%","default":{"mode":"loadAllButExcluded","excludedModules":[]},"type":"object","required":["mode"],"properties":{"mode":{"type":"string","enum":["loadAllButExcluded","loadOnlyIncluded"],"enumDescriptions":["%generateOptionsSchema.symbolOptions.moduleFilter.mode.loadAllButExcluded.enumDescription%","%generateOptionsSchema.symbolOptions.moduleFilter.mode.loadOnlyIncluded.enumDescription%"],"description":"%generateOptionsSchema.symbolOptions.moduleFilter.mode.description%","default":"loadAllButExcluded"},"excludedModules":{"type":"array","items":{"type":"string"},"description":"%generateOptionsSchema.symbolOptions.moduleFilter.excludedModules.description%","default":[]},"includedModules":{"type":"array","items":{"type":"string"},"description":"%generateOptionsSchema.symbolOptions.moduleFilter.includedModules.description%","default":[]},"includeSymbolsNextToModules":{"type":"boolean","description":"%generateOptionsSchema.symbolOptions.moduleFilter.includeSymbolsNextToModules.description%","default":true},"includeSymbolsOnDemand":{"type":"boolean","description":"%generateOptionsSchema.symbolOptions.moduleFilter.includeSymbolsOnDemand.description%","default":true}}}}},"sourceLinkOptions":{"markdownDescription":"%generateOptionsSchema.sourceLinkOptions.markdownDescription%","default":{"*":{"enabled":true}},"type":"object","additionalItems":{"type":"object","properties":{"enabled":{"title":"boolean","markdownDescription":"%generateOptionsSchema.sourceLinkOptions.additionalItems.enabled.markdownDescription%","default":true}}}},"expressionEvaluationOptions":{"description":"%generateOptionsSchema.expressionEvaluationOptions.description%","default":{},"type":"object","properties":{"allowImplicitFuncEval":{"type":"boolean","description":"%generateOptionsSchema.expressionEvaluationOptions.allowImplicitFuncEval.description%","default":true},"allowToString":{"type":"boolean","markdownDescription":"%generateOptionsSchema.expressionEvaluationOptions.allowToString.markdownDescription%","default":true},"allowFastEvaluate":{"type":"boolean","description":"%generateOptionsSchema.expressionEvaluationOptions.allowFastEvaluate.description%","default":true},"showRawValues":{"type":"boolean","description":"%generateOptionsSchema.expressionEvaluationOptions.showRawValues.description%","default":false}}},"targetArchitecture":{"type":"string","markdownDescription":"%generateOptionsSchema.targetArchitecture.markdownDescription%","enum":["x86_64","arm64"]},"type":{"type":"string","enum":["coreclr","clr"],"markdownDescription":"%generateOptionsSchema.type.markdownDescription%","default":"coreclr"},"debugServer":{"type":"number","description":"%generateOptionsSchema.debugServer.description%","default":4711}}},"dotnet.unitTests.runSettingsPath":{"type":"string","markdownDescription":"%configuration.dotnet.unitTests.runSettingsPath%"}}},{"title":"LSP Server","order":9,"properties":{"dotnet.preferCSharpExtension":{"scope":"resource","type":"boolean","default":false,"description":"%configuration.dotnet.preferCSharpExtension%"},"dotnet.server.path":{"type":"string","scope":"machine-overridable","description":"%configuration.dotnet.server.path%"},"dotnet.server.componentPaths":{"type":"object","description":"%configuration.dotnet.server.componentPaths%","properties":{"roslynDevKit":{"description":"%configuration.dotnet.server.componentPaths.roslynDevKit%","type":"string"},"xamlTools":{"description":"%configuration.dotnet.server.componentPaths.xamlTools%","type":"string"}},"default":{}},"dotnet.server.startTimeout":{"type":"number","scope":"machine-overridable","default":120000,"description":"%configuration.dotnet.server.startTimeout%"},"dotnet.server.waitForDebugger":{"type":"boolean","scope":"machine-overridable","default":false,"description":"%configuration.dotnet.server.waitForDebugger%"},"dotnet.server.extensionPaths":{"scope":"machine-overridable","type":["array",null],"items":{"type":"string"},"default":null,"description":"%configuration.dotnet.server.extensionPaths%"},"dotnet.server.crashDumpPath":{"scope":"machine-overridable","type":"string","default":null,"description":"%configuration.dotnet.server.crashDumpPath%"},"dotnet.server.suppressLspErrorToasts":{"type":"boolean","default":false,"description":"%configuration.dotnet.server.suppressLspErrorToasts%"},"dotnet.server.suppressMiscellaneousFilesToasts":{"type":"boolean","default":false,"description":"%configuration.dotnet.server.suppressMiscellaneousFilesToasts%"},"dotnet.server.useServerGC":{"type":"boolean","default":true,"description":"%configuration.dotnet.server.useServerGC%"},"dotnet.enableXamlTools":{"scope":"machine-overridable","type":"boolean","default":true,"description":"%configuration.dotnet.enableXamlTools%"},"dotnet.projects.binaryLogPath":{"scope":"machine-overridable","type":"string","default":null,"description":"%configuration.dotnet.projects.binaryLogPath%"},"dotnet.projects.enableAutomaticRestore":{"type":"boolean","default":true,"description":"%configuration.dotnet.projects.enableAutomaticRestore%"},"razor.languageServer.directory":{"type":"string","scope":"machine-overridable","description":"%configuration.razor.languageServer.directory%","order":90},"razor.languageServer.debug":{"type":"boolean","scope":"machine-overridable","default":false,"description":"%configuration.razor.languageServer.debug%","order":90},"razor.languageServer.forceRuntimeCodeGeneration":{"type":"boolean","scope":"machine-overridable","default":null,"description":"%configuration.razor.languageServer.forceRuntimeCodeGeneration%","order":90},"razor.languageServer.suppressLspErrorToasts":{"type":"boolean","default":true,"description":"%configuration.razor.languageServer.suppressLspErrorToasts%"},"razor.languageServer.useNewFormattingEngine":{"type":"boolean","default":true,"description":"%configuration.razor.languageServer.useNewFormattingEngine%"}}},{"title":"OmniSharp","order":10,"properties":{"dotnet.server.useOmnisharp":{"type":"boolean","default":false,"description":"%configuration.omnisharp.dotnet.server.useOmnisharp%","order":0},"omnisharp.dotnetPath":{"type":"string","scope":"machine-overridable","description":"%configuration.omnisharp.dotnetPath%"},"csharp.format.enable":{"type":"boolean","default":true,"description":"%configuration.omnisharp.csharp.format.enable%"},"csharp.suppressDotnetInstallWarning":{"type":"boolean","default":false,"description":"%configuration.omnisharp.csharp.suppressDotnetInstallWarning%"},"csharp.suppressDotnetRestoreNotification":{"type":"boolean","default":false,"description":"%configuration.omnisharp.csharp.suppressDotnetRestoreNotification%"},"csharp.suppressProjectJsonWarning":{"type":"boolean","default":false,"description":"%configuration.omnisharp.csharp.suppressProjectJsonWarning%"},"csharp.suppressBuildAssetsNotification":{"type":"boolean","default":false,"description":"%configuration.omnisharp.csharp.suppressBuildAssetsNotification%"},"csharp.suppressHiddenDiagnostics":{"type":"boolean","default":true,"description":"%configuration.omnisharp.csharp.suppressHiddenDiagnostics%"},"csharp.referencesCodeLens.filteredSymbols":{"type":"array","items":{"type":"string"},"default":[],"description":"%configuration.omnisharp.csharp.referencesCodeLens.filteredSymbols%"},"csharp.maxProjectFileCountForDiagnosticAnalysis":{"type":"number","default":1000,"description":"%configuration.omnisharp.csharp.maxProjectFileCountForDiagnosticAnalysis%"},"csharp.semanticHighlighting.enabled":{"type":"boolean","default":true,"description":"%configuration.omnisharp.csharp.semanticHighlighting.enabled%","scope":"window"},"csharp.showOmnisharpLogOnError":{"type":"boolean","default":true,"description":"%configuration.omnisharp.csharp.showOmnisharpLogOnError%"},"omnisharp.useModernNet":{"type":"boolean","default":true,"scope":"window","title":"%configuration.omnisharp.useModernNet.title%","description":"%configuration.omnisharp.useModernNet.description%"},"omnisharp.sdkPath":{"type":"string","scope":"window","description":"%configuration.omnisharp.sdkPath%"},"omnisharp.sdkVersion":{"type":"string","scope":"window","description":"%configuration.omnisharp.sdkVersion%"},"omnisharp.sdkIncludePrereleases":{"type":"boolean","scope":"window","default":true,"description":"%configuration.omnisharp.sdkIncludePrereleases%"},"omnisharp.monoPath":{"type":"string","scope":"machine","description":"%configuration.omnisharp.monoPath%"},"omnisharp.loggingLevel":{"type":"string","default":"information","enum":["trace","debug","information","warning","error","critical"],"description":"%configuration.omnisharp.loggingLevel%"},"omnisharp.autoStart":{"type":"boolean","default":true,"description":"%configuration.omnisharp.autoStart%"},"omnisharp.projectFilesExcludePattern":{"type":"string","default":"**/node_modules/**,**/.git/**,**/bower_components/**","description":"%configuration.omnisharp.projectFilesExcludePattern%"},"omnisharp.projectLoadTimeout":{"type":"number","default":60,"description":"%configuration.omnisharp.projectLoadTimeout%"},"omnisharp.maxProjectResults":{"type":"number","default":250,"description":"%configuration.omnisharp.maxProjectResults%"},"omnisharp.useEditorFormattingSettings":{"type":"boolean","default":true,"description":"%configuration.omnisharp.useEditorFormattingSettings%"},"omnisharp.minFindSymbolsFilterLength":{"type":"number","default":0,"description":"%configuration.omnisharp.minFindSymbolsFilterLength%"},"omnisharp.maxFindSymbolsItems":{"type":"number","default":1000,"description":"%configuration.omnisharp.maxFindSymbolsItems%"},"omnisharp.disableMSBuildDiagnosticWarning":{"type":"boolean","default":false,"description":"%configuration.omnisharp.disableMSBuildDiagnosticWarning%"},"omnisharp.enableMsBuildLoadProjectsOnDemand":{"type":"boolean","default":false,"description":"%configuration.omnisharp.enableMsBuildLoadProjectsOnDemand%"},"omnisharp.enableEditorConfigSupport":{"type":"boolean","default":true,"description":"%configuration.omnisharp.enableEditorConfigSupport%"},"omnisharp.enableDecompilationSupport":{"type":"boolean","default":false,"scope":"machine","description":"%configuration.omnisharp.enableDecompilationSupport%"},"omnisharp.enableLspDriver":{"type":"boolean","default":false,"description":"%configuration.omnisharp.enableLspDriver%"},"omnisharp.enableAsyncCompletion":{"type":"boolean","default":false,"description":"%configuration.omnisharp.enableAsyncCompletion%"},"omnisharp.dotNetCliPaths":{"type":"array","items":{"type":"string"},"description":"%configuration.omnisharp.dotNetCliPaths%","uniqueItems":true},"razor.plugin.path":{"type":"string","scope":"machine","description":"%configuration.omnisharp.razor.plugin.path%"},"razor.devmode":{"type":"boolean","default":false,"description":"%configuration.omnisharp.razor.devmode%"},"razor.format.enable":{"type":"boolean","scope":"window","default":true,"description":"%configuration.omnisharp.razor.format.enable%"},"razor.format.codeBlockBraceOnNextLine":{"type":"boolean","scope":"window","default":false,"description":"%configuration.omnisharp.razor.format.codeBlockBraceOnNextLine%"},"razor.completion.commitElementsWithSpace":{"type":"boolean","scope":"window","default":false,"description":"%configuration.omnisharp.razor.completion.commitElementsWithSpace%"}}}],"jsonValidation":[{"fileMatch":["appsettings.json","appsettings.*.json"],"url":"https://json.schemastore.org/appsettings"},{"fileMatch":"omnisharp.json","url":"http://json.schemastore.org/omnisharp"},{"fileMatch":"global.json","url":"http://json.schemastore.org/global"},{"fileMatch":"launchSettings.json","url":"https://json.schemastore.org/launchsettings.json"}],"snippets":[{"language":"csharp","path":"./snippets/csharp.json"}],"semanticTokenTypes":[{"id":"razorComponentElement","description":"A Razor component element"},{"id":"razorComponentAttribute","description":"A Razor component attribute"},{"id":"razorTagHelperElement","description":"A Razor TagHelper Element"},{"id":"razorTagHelperAttribute","description":"A Razor TagHelper Attribute"},{"id":"razorTransition","description":"A Razor transition"},{"id":"razorDirectiveAttribute","description":"A Razor Directive Attribute"},{"id":"razorDirectiveColon","description":"A colon between directive attribute parameters"},{"id":"razorDirective","description":"A Razor directive such as 'code' or 'function'"},{"id":"razorComment","description":"A Razor comment"},{"id":"markupCommentPunctuation","description":"The '@' or '*' of a Razor comment."},{"id":"markupTagDelimiter","description":"Markup delimiters like '<', '>', and '/'."},{"id":"markupOperator","description":"Delimiter for Markup Attribute Key-Value pairs."},{"id":"markupElement","description":"The name of a Markup element."},{"id":"markupAttribute","description":"The name of a Markup attribute."},{"id":"markupAttributeQuote","description":"A token that represents an attribute quote in a Markup attribute."},{"id":"markupAttributeValue","description":"The value of a Markup attribute."},{"id":"markupComment","description":"The contents of a Markup comment."},{"id":"markupCommentPunctuation","description":"The begining or ending punctuation of a Markup comment."},{"id":"excludedCode","description":"A token that represents inactive code."},{"id":"controlKeyword","description":"A token that represents a control-flow keyword.","superType":"keyword"},{"id":"operatorOverloaded","description":"A declaration or reference to an overloaded operator."},{"id":"whitespace","description":"A token that represents whitespace."},{"id":"text","description":"A token that represents text."},{"id":"preprocessorText","description":"Text associated with a preprocessor directive."},{"id":"punctuation","description":"A token that represents punctuation."},{"id":"stringVerbatim","superType":"string","description":"A token that represents a verbatim string."},{"id":"stringEscapeCharacter","superType":"string","description":"An escape character within a string."},{"id":"recordClass","superType":"class","description":"A definition or reference to a record class type."},{"id":"delegate","superType":"method","description":"A definition or reference to a delegate type."},{"id":"module","superType":"namespace","description":"A definition or reference to a module name."},{"id":"recordStruct","superType":"struct","description":"A definition or reference to a record struct type."},{"id":"field","superType":"property","description":"A definition or reference to a field."},{"id":"constant","superType":"variable","description":"A definition or reference to a constant."},{"id":"extensionMethod","superType":"method","description":"A definition or reference to an extension method"},{"id":"xmlDocCommentAttributeName","description":"A token that represents an attribute in an XML documentation comment"},{"id":"xmlDocCommentAttributeQuotes","description":"A token that represents an attribute quote in an XML documentation comment"},{"id":"xmlDocCommentAttributeValue","description":"A token that represents an attribute value in an XML documentation comment"},{"id":"xmlDocCommentCDataSection","description":"A token that represents a CDATA section in an XML documentation comment"},{"id":"xmlDocCommentComment","description":"A token that represents a comment in an XML documentation comment"},{"id":"xmlDocCommentDelimiter","description":"A token that represents a delimeter in an XML documentation comment"},{"id":"xmlDocCommentEntityReference","description":"A token that represents reference to an entity in an XML documentation comment"},{"id":"xmlDocCommentName","description":"A token that represents a name in an XML documentation comment"},{"id":"xmlDocCommentProcessingInstruction","description":"A token that represents a processing instruction in an XML documentation comment"},{"id":"xmlDocCommentText","description":"A token that represents text in an XML documentation comment"},{"id":"xmlLiteralAttributeName","description":"A token that represents an attribute name in an XML literal"},{"id":"xmlLiteralAttributeQuotes","description":"A token that represents an attribute quote in an XML literal"},{"id":"xmlLiteralAttributeValue","description":"A token that represents an attribute value in an XML literal"},{"id":"xmlLiteralCDataSection","description":"A token that represents a CDATA section in an XML literal"},{"id":"xmlLiteralComment","description":"A token that represents a comment in an XML literal"},{"id":"xmlLiteralDelimiter","description":"A token that represents a delimiter in an XML literal"},{"id":"xmlLiteralEmbeddedExpression","description":"A token that represents an emebedded expression in an XML literal"},{"id":"xmlLiteralEntityReference","description":"A token that represents a reference to an entity in an XML literal"},{"id":"xmlLiteralName","description":"A token that represents a name in an XML literal"},{"id":"xmlLiteralProcessingInstruction","description":"A token that represents a processing instruction in an XML literal"},{"id":"xmlLiteralText","description":"A token that represents text in an XML literal"},{"id":"regexComment","description":"A token that represents a comment in a regex string"},{"id":"regexCharacterClass","description":"A token that represents a character class in a regex string"},{"id":"regexAnchor","description":"A token that represents an anchor in a regex string"},{"id":"regexQuantifier","description":"A token that represents a quantifier in a regex string"},{"id":"regexGrouping","description":"A token that represents a group in a regex string"},{"id":"regexAlternation","description":"A token that represents an alternation in a regex string"},{"id":"regexText","description":"A token that represents text in a regex string"},{"id":"regexSelfEscapedCharacter","description":"A token that represents a self escaped character in a regex string"},{"id":"regexOtherEscape","description":"A token that represents an escape in a regex string"},{"id":"jsonComment","description":"A token that represents a comment in a JSON string"},{"id":"jsonNumber","description":"A token that represents a number in a JSON string"},{"id":"jsonString","description":"A token that represents a string in a JSON string"},{"id":"jsonKeyword","description":"A token that represents a keyword in a JSON string"},{"id":"jsonText","description":"A token that represents text in a JSON string"},{"id":"jsonOperator","description":"A token that represents an operator in a JSON string"},{"id":"jsonPunctuation","description":"A token that represents punctuation in a JSON string"},{"id":"jsonArray","description":"A token that represents an array in a JSON string"},{"id":"jsonObject","description":"A token that represents an object in a JSON string"},{"id":"jsonPropertyName","description":"A token that represents a property name in a JSON string"},{"id":"jsonConstructorName","description":"A token that represents a constructor in a JSON string"}],"semanticTokenModifiers":[],"semanticTokenScopes":[{"language":"aspnetcorerazor","scopes":{"razorComponentElement":["entity.name.class.element.component"],"razorComponentAttribute":["entity.name.class.attribute.component"],"razorTagHelperElement":["entity.name.class.element.taghelper"],"razorTagHelperAttribute":["entity.name.class.attribute.taghelper"],"razorTransition":["keyword.control.razor.transition"],"razorDirectiveAttribute":["keyword.control.razor.directive.attribute","keyword.control.cshtml.directive.attribute"],"razorDirectiveColon":["keyword.control.razor.directive.colon","keyword.control.cshtml.directive.colon"],"razorDirective":["keyword.control.razor.directive","keyword.control.cshtml.directive"],"razorComment":["comment.block.razor"],"razorCommentTransition":["meta.comment.razor","keyword.control.cshtml.transition"],"razorCommentStar":["keyword.control.razor.comment.star","meta.comment.razor"],"angleBracket":["punctuation.definition.tag"],"forwardSlash":["punctuation.definition.tag"],"equals":["punctuation.separator.key-value.html"],"markupElement":["entity.name.tag.html"],"markupAttribute":["entity.other.attribute-name.html"],"markupAttributeQuote":["punctuation.definition.tag.html"],"markupAttributeValue":["punctuation.definition.entity.html"],"markupComment":["comment.block.html"],"markupCommentPunctuation":["punctuation.definition.comment.html","comment.block.html"],"markupTagDelimiter":["punctuation.definition.tag.html"],"keyword":["keyword.cs"],"excludedCode":["support.other.excluded.cs"],"controlKeyword":["keyword.control.cs"],"operatorOverloaded":["entity.name.function.member.overload.cs"],"preprocessorText":["meta.preprocessor.string.cs"],"punctuation":["punctuation.cs"],"stringVerbatim":["string.verbatim.cs"],"stringEscapeCharacter":["constant.character.escape.cs"],"delegate":["entity.name.type.delegate.cs"],"module":["entity.name.type.module.cs"],"field":["entity.name.variable.field.cs"],"constant":["variable.other.constant"],"extensionMethod":["entity.name.function.extension.cs"],"xmlDocCommentAttributeName":["comment.documentation.attribute.name.cs"],"xmlDocCommentAttributeQuotes":["comment.documentation.attribute.quotes.cs"],"xmlDocCommentAttributeValue":["comment.documentation.attribute.value.cs"],"xmlDocCommentCDataSection":["comment.documentation.cdata.cs"],"xmlDocCommentComment":["comment.documentation.comment.cs"],"xmlDocCommentDelimiter":["comment.documentation.delimiter.cs"],"xmlDocCommentEntityReference":["comment.documentation.entityReference.cs"],"xmlDocCommentName":["comment.documentation.name.cs"],"xmlDocCommentProcessingInstruction":["comment.documentation.processingInstruction.cs"],"xmlDocCommentText":["comment.documentation.cs"],"xmlLiteralAttributeName":["entity.other.attribute-name.localname.xml"],"xmlLiteralAttributeQuotes":["string.quoted.double.xml"],"xmlLiteralAttributeValue":["meta.tag.xml"],"xmlLiteralCDataSection":["string.quoted.double.xml"],"xmlLiteralComment":["comment.block.xml"],"xmlLiteralDelimiter":["text.xml"],"xmlLiteralEmbeddedExpression":["meta.tag.xml"],"xmlLiteralEntityReference":["meta.tag.xml"],"xmlLiteralName":["entity.name.tag.localname.xml"],"xmlLiteralProcessingInstruction":["meta.tag.xml"],"xmlLiteralText":["text.xml"],"regexComment":["string.regexp.comment.cs"],"regexCharacterClass":["constant.character.character-class.regexp.cs"],"regexAnchor":["keyword.control.anchor.regexp.cs"],"regexQuantifier":["keyword.operator.quantifier.regexp.cs"],"regexGrouping":["punctuation.definition.group.regexp.cs"],"regexAlternation":["keyword.operator.or.regexp.cs"],"regexText":["string.regexp"],"regexSelfEscapedCharacter":["string.regexp.self-escaped-character.cs"],"regexOtherEscape":["string.regexp.other-escape.cs"],"jsonComment":["comment.line.double-slash.js"],"jsonNumber":["constant.numeric.json"],"jsonString":["string.quoted.double.json"],"jsonKeyword":["constant.language.json"],"jsonText":["string.quoted.double.json"],"jsonOperator":["string.quoted.double.json"],"jsonPunctuation":["punctuation.separator.dictionary.key-value.json"],"jsonArray":["punctuation.definition.array.begin.json"],"jsonObject":["punctuation.definition.dictionary.begin.json"],"jsonPropertyName":["support.type.property-name.json"],"jsonConstructorName":["support.type.property-name.json"]}},{"language":"csharp","scopes":{"typeParameter":["entity.name.type.type-parameter"],"keyword":["keyword.cs"],"excludedCode":["support.other.excluded.cs"],"controlKeyword":["keyword.control.cs"],"operatorOverloaded":["entity.name.function.member.overload.cs"],"preprocessorText":["meta.preprocessor.string.cs"],"punctuation":["punctuation.cs"],"stringVerbatim":["string.verbatim.cs"],"stringEscapeCharacter":["constant.character.escape.cs"],"delegate":["entity.name.type.delegate.cs"],"module":["entity.name.type.module.cs"],"field":["entity.name.variable.field.cs"],"constant":["variable.other.constant"],"extensionMethod":["entity.name.function.extension.cs"],"xmlDocCommentAttributeName":["comment.documentation.attribute.name.cs"],"xmlDocCommentAttributeQuotes":["comment.documentation.attribute.quotes.cs"],"xmlDocCommentAttributeValue":["comment.documentation.attribute.value.cs"],"xmlDocCommentCDataSection":["comment.documentation.cdata.cs"],"xmlDocCommentComment":["comment.documentation.comment.cs"],"xmlDocCommentDelimiter":["comment.documentation.delimiter.cs"],"xmlDocCommentEntityReference":["comment.documentation.entityReference.cs"],"xmlDocCommentName":["comment.documentation.name.cs"],"xmlDocCommentProcessingInstruction":["comment.documentation.processingInstruction.cs"],"xmlDocCommentText":["comment.documentation.cs"],"xmlLiteralAttributeName":["entity.other.attribute-name.localname.xml"],"xmlLiteralAttributeQuotes":["string.quoted.double.xml"],"xmlLiteralAttributeValue":["meta.tag.xml"],"xmlLiteralCDataSection":["string.quoted.double.xml"],"xmlLiteralComment":["comment.block.xml"],"xmlLiteralDelimiter":["text.xml"],"xmlLiteralEmbeddedExpression":["meta.tag.xml"],"xmlLiteralEntityReference":["meta.tag.xml"],"xmlLiteralName":["entity.name.tag.localname.xml"],"xmlLiteralProcessingInstruction":["meta.tag.xml"],"xmlLiteralText":["text.xml"],"regexComment":["string.regexp.comment.cs"],"regexCharacterClass":["constant.character.character-class.regexp.cs"],"regexAnchor":["keyword.control.anchor.regexp.cs"],"regexQuantifier":["keyword.operator.quantifier.regexp.cs"],"regexGrouping":["punctuation.definition.group.regexp.cs"],"regexAlternation":["keyword.operator.or.regexp.cs"],"regexText":["string.regexp"],"regexSelfEscapedCharacter":["string.regexp.self-escaped-character.cs"],"regexOtherEscape":["string.regexp.other-escape.cs"],"jsonComment":["comment.line.double-slash.js"],"jsonNumber":["constant.numeric.json"],"jsonString":["string.quoted.double.json"],"jsonKeyword":["constant.language.json"],"jsonText":["string.quoted.double.json"],"jsonOperator":["string.quoted.double.json"],"jsonPunctuation":["punctuation.separator.dictionary.key-value.json"],"jsonArray":["punctuation.definition.array.begin.json"],"jsonObject":["punctuation.definition.dictionary.begin.json"],"jsonPropertyName":["support.type.property-name.json"],"jsonConstructorName":["support.type.property-name.json"]}}],"languages":[{"id":"aspnetcorerazor","extensions":[".cshtml",".razor"],"mimetypes":["text/x-cshtml"],"configuration":"./src/razor/language-configuration.json","aliases":["ASP.NET Razor"]},{"id":"xaml","extensions":[".xaml"],"configuration":"./src/xaml/language-configuration.json","aliases":["XAML"]}],"grammars":[{"language":"aspnetcorerazor","scopeName":"text.aspnetcorerazor","path":"./src/razor/syntaxes/aspnetcorerazor.tmLanguage.json","unbalancedBracketScopes":["text.aspnetcorerazor"]},{"language":"xaml","scopeName":"source.xaml","path":"./src/xaml/syntaxes/xaml.tmLanguage.json"}],"configurationDefaults":{"[xaml]":{"editor.wordBasedSuggestions":"off"}}}};

const { registerFileUrl, whenReady } = registerExtension(manifest, undefined, {"system":true,"readmePath":"README.md","changelogPath":"CHANGELOG.md"});


registerFileUrl('CHANGELOG.md', new URL('../assets/ms-dotnettools.csharp-2.63.31.vsix/CHANGELOG.md', import.meta.url).href, {"mimeType":"text/markdown","size":264097});

registerFileUrl('README.md', new URL('../assets/ms-dotnettools.csharp-2.63.31.vsix/README.md', import.meta.url).href, {"mimeType":"text/markdown","size":5962});

registerFileUrl('images/csharpIcon.png', new URL('../assets/ms-dotnettools.csharp-2.63.31.vsix/csharpIcon.png', import.meta.url).href, {"mimeType":"image/png","size":41371});

registerFileUrl('package.json', new URL('../assets/ms-dotnettools.csharp-2.63.31.vsix/package.json', import.meta.url).href, {"mimeType":"application/json","size":227893});

registerFileUrl('package.nls.cs.json', new URL('../assets/ms-dotnettools.csharp-2.63.31.vsix/package.nls.cs.json', import.meta.url).href, {"mimeType":"application/json","size":52524});

registerFileUrl('package.nls.de.json', new URL('../assets/ms-dotnettools.csharp-2.63.31.vsix/package.nls.de.json', import.meta.url).href, {"mimeType":"application/json","size":54543});

registerFileUrl('package.nls.es.json', new URL('../assets/ms-dotnettools.csharp-2.63.31.vsix/package.nls.es.json', import.meta.url).href, {"mimeType":"application/json","size":54002});

registerFileUrl('package.nls.fr.json', new URL('../assets/ms-dotnettools.csharp-2.63.31.vsix/package.nls.fr.json', import.meta.url).href, {"mimeType":"application/json","size":54805});

registerFileUrl('package.nls.it.json', new URL('../assets/ms-dotnettools.csharp-2.63.31.vsix/package.nls.it.json', import.meta.url).href, {"mimeType":"application/json","size":53499});

registerFileUrl('package.nls.ja.json', new URL('../assets/ms-dotnettools.csharp-2.63.31.vsix/package.nls.ja.json', import.meta.url).href, {"mimeType":"application/json","size":59587});

registerFileUrl('package.nls.json', new URL('../assets/ms-dotnettools.csharp-2.63.31.vsix/package.nls.json', import.meta.url).href, {"mimeType":"application/json","size":57399});

registerFileUrl('package.nls.ko.json', new URL('../assets/ms-dotnettools.csharp-2.63.31.vsix/package.nls.ko.json', import.meta.url).href, {"mimeType":"application/json","size":52593});

registerFileUrl('package.nls.pl.json', new URL('../assets/ms-dotnettools.csharp-2.63.31.vsix/package.nls.pl.json', import.meta.url).href, {"mimeType":"application/json","size":55146});

registerFileUrl('package.nls.pt-br.json', new URL('../assets/ms-dotnettools.csharp-2.63.31.vsix/package.nls.pt-br.json', import.meta.url).href, {"mimeType":"application/json","size":51737});

registerFileUrl('package.nls.ru.json', new URL('../assets/ms-dotnettools.csharp-2.63.31.vsix/package.nls.ru.json', import.meta.url).href, {"mimeType":"application/json","size":75090});

registerFileUrl('package.nls.tr.json', new URL('../assets/ms-dotnettools.csharp-2.63.31.vsix/package.nls.tr.json', import.meta.url).href, {"mimeType":"application/json","size":53375});

registerFileUrl('package.nls.zh-cn.json', new URL('../assets/ms-dotnettools.csharp-2.63.31.vsix/package.nls.zh-cn.json', import.meta.url).href, {"mimeType":"application/json","size":44194});

registerFileUrl('package.nls.zh-tw.json', new URL('../assets/ms-dotnettools.csharp-2.63.31.vsix/package.nls.zh-tw.json', import.meta.url).href, {"mimeType":"application/json","size":44158});

registerFileUrl('snippets/csharp.json', new URL('../assets/ms-dotnettools.csharp-2.63.31.vsix/csharp.json', import.meta.url).href, {"mimeType":"application/json","size":13805});

registerFileUrl('src/razor/language-configuration.json', new URL('../assets/ms-dotnettools.csharp-2.63.31.vsix/language-configuration.json', import.meta.url).href, {"mimeType":"application/json","size":486});

registerFileUrl('src/razor/syntaxes/aspnetcorerazor.tmLanguage.json', new URL('../assets/ms-dotnettools.csharp-2.63.31.vsix/aspnetcorerazor.tmLanguage.json', import.meta.url).href, {"mimeType":"application/json","size":44116});

registerFileUrl('src/xaml/language-configuration.json', new URL('../assets/ms-dotnettools.csharp-2.63.31.vsix/language-configuration2.json', import.meta.url).href, {"mimeType":"application/json","size":1394});

registerFileUrl('src/xaml/syntaxes/xaml.tmLanguage.json', new URL('../assets/ms-dotnettools.csharp-2.63.31.vsix/xaml.tmLanguage.json', import.meta.url).href, {"mimeType":"application/json","size":7993});

registerFileUrl('themes/vs2019_dark.json', new URL('../assets/ms-dotnettools.csharp-2.63.31.vsix/vs2019_dark.json', import.meta.url).href, {"mimeType":"application/json","size":22886});

registerFileUrl('themes/vs2019_light.json', new URL('../assets/ms-dotnettools.csharp-2.63.31.vsix/vs2019_light.json', import.meta.url).href, {"mimeType":"application/json","size":23980});

export { whenReady };
